<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="100px">

      <el-form-item label="企微昵称" prop="nickName" >
        <el-input
          v-model="queryParams.nickName"
          placeholder="请输入企微昵称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>


      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker v-model="createTime" size="small" style="width: 220px" value-format="yyyy-MM-dd" type="daterange"
                        range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" @change="createChange"></el-date-picker>
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table border v-loading="loading" :data="courseWatchLogList" @selection-change="handleSelectionChange">
      <el-table-column label="企微客户" align="center" prop="externalUserName"/>
      <el-table-column label="客户头像" align="center" prop="avatar">
        <template slot-scope="scope">
            <el-popover
              placement="right"
              title=""
              trigger="hover">
              <img slot="reference" :src="scope.row.avatar" style="width: 40px;height: 40px">
              <img :src="scope.row.avatar" style="max-width: 250px;max-height: 250px">
            </el-popover>
        </template>
      </el-table-column>
<!--      <el-table-column label="所属销售" align="center" prop="companyUserName" /> -->
      <el-table-column label="企微员工名称" align="center" prop="qwUserName" />
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <el-table-column label="进线时间" align="center" prop="userCreateTime" />
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

  </div>
</template>

<script>
import { listCourseWatchLog, getCourseWatchLog, delCourseWatchLog, addCourseWatchLog, updateCourseWatchLog, exportCourseWatchLog,watchLogStatistics,watchLogStatisticsExport } from "@/api/course/courseWatchLog";
import {allList}from "@/api/company/company";
import { courseList,videoList } from '@/api/course/courseRedPacketLog'
import {getDateRange} from "@/utils/common";
export default {
  name: "CourseWatchLog",
  data() {
    return {
      activeName:"00",
      createTime:null,
      updateTime:null,
      courseLists:[],
      videoList:[],
      logTypeOptions:[],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 短链课程看课记录表格数据
      courseWatchLogList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userId: null,
        nickName: null,
        videoId: null,
        logType: null,
        qwExternalContactId: null,
        externalUserName:null,
        duration: null,
        qwUserId: null,
        companyUserId: null,
        companyId: null,
        courseId: null,
        sTime:null,
        eTime:null,
        upSTime:null,
        upETime:null,
        scheduleStartTime: null,
        scheduleEndTime: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      scheduleTime: null,
    };
  },
  created() {
    // // 设置默认时间范围为最近7天
    // this.createTime = getDateRange(7);
    // // 设置查询参数的时间
    // this.queryParams.sTime = this.createTime[0];
    // this.queryParams.eTime = this.createTime[1];

    courseList().then(response => {
      this.courseLists = response.list;
    });
    this.getList();
    this.getDicts("sys_course_watch_log_type").then(response => {
      this.logTypeOptions = response.data;
    });
  },
  methods: {
    courseChange(row){
      this.queryParams.videoId=null;
      if(row === ''){
        this.videoList=[];
        return
      }
      videoList(row).then(response => {
        this.videoList=response.list
      });
    },
    createChange() {
      if (this.createTime != null) {
        this.queryParams.sTime = this.createTime[0];
        this.queryParams.eTime = this.createTime[1];
      } else {
        this.queryParams.sTime = null;
        this.queryParams.eTime = null;
      }
    },

    updateChange(){
      if (this.updateTime != null) {
        this.queryParams.upSTime = this.updateTime[0];
        this.queryParams.upETime = this.updateTime[1];
      } else {
        this.queryParams.upSTime = null;
        this.queryParams.upETime = null;
      }
    },
    handleClickX(tab,event){
      this.activeName=tab.name;
      if(tab.name=="00"){
        this.queryParams.logType=null;
      }else{
        this.queryParams.logType=tab.name;
      }
      this.getList()
    },
    /** 查询短链课程看课记录列表 */
    getList() {
      this.loading = true;
      if(this.queryParams.logType == "10"){
        this.queryParams.logType = null;
      }

      watchLogStatistics(this.queryParams).then(response => {
        this.courseWatchLogList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        logId: null,
        userId: null,
        videoId: null,
        logType: null,
        createTime: null,
        updateTime: null,
        qwExternalContactId: null,
        externalUserName:null,
        duration: null,
        qwUserId: null,
        companyUserId: null,
        companyId: null,
        courseId: null,
        scheduleStartTime: null,
        scheduleEndTime: null,
      };
      this.scheduleTime=null;
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      if (!this.queryParams.sTime || !this.queryParams.eTime) {
        this.$message.warning("请选择创建时间");
        return;
      }
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.createTime = null;
      this.scheduleTime = null;
      this.queryParams.sTime = null;
      this.queryParams.eTime = null;
      this.queryParams.upSTime = null;
      this.queryParams.upETime = null;
      this.queryParams.scheduleStartTime = null;
      this.queryParams.scheduleEndTime = null;
      this.queryParams.externalUserName=null;
      this.scheduleTime=null;
      this.updateTime=null;

      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.logId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加短链课程看课记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const logId = row.logId || this.ids
      getCourseWatchLog(logId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改短链课程看课记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.logId != null) {
            updateCourseWatchLog(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addCourseWatchLog(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const logIds = row.logId || this.ids;
      this.$confirm('是否确认删除短链课程看课记录编号为"' + logIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delCourseWatchLog(logIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有短链课程看课记录数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return watchLogStatisticsExport(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    handleScheduleTimeChange(val) {
      if (val) {
        this.queryParams.scheduleStartTime = val[0];
        this.queryParams.scheduleEndTime = val[1];
      } else {
        this.queryParams.scheduleStartTime = null;
        this.queryParams.scheduleEndTime = null;
      }
    },
  }
};
</script>
